﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// http://bbs.csdn.net/topics/390529029
// 以非递归的方式统计一个文件夹大小的程序

namespace Csdn390529029
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            string path = (string)e.Argument;

            Stack<DirectoryInfo> stack;
            DirectoryInfo dir;
            long sum = 0;

            dir = new DirectoryInfo(path);

            if (dir.Exists)
            {
                stack = new Stack<DirectoryInfo>();
                stack.Push(dir);

                while (stack.Count > 0)
                {
                    if (backgroundWorker1.CancellationPending)
                    {
                        e.Cancel = true;
                        break;
                    }

                    dir = stack.Pop();
                    backgroundWorker1.ReportProgress(0, dir);
                    try
                    {
                        sum += dir.GetFiles().Sum(o => o.Length);
                    }
                    catch (UnauthorizedAccessException)
                    {
                        continue;
                    }

                    var subdirs = dir.GetDirectories();

                    foreach (var sub in subdirs)
                    {
                        stack.Push(sub);
                    }

                }
            }
            else
                sum = -1;

            e.Result = sum;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.SelectedPath = textBox1.Text;
            if (folderBrowserDialog1.ShowDialog(this) == System.Windows.Forms.DialogResult.OK)
            {
                textBox1.Text = folderBrowserDialog1.SelectedPath;
            }
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {

            if (!e.Cancelled)
            {
                textBox2.Text = ((long)e.Result).ToString("N0");
            }
            else
                textBox2.Text = "已被用户中止";

            label3.Visible = false;
            button2.Text = "开始";
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (!backgroundWorker1.IsBusy)
            {
                textBox2.Text = "正在统计...";
                label3.Text = string.Empty;
                label3.Visible = true;
                button2.Text = "停止";
                backgroundWorker1.RunWorkerAsync(textBox1.Text);
            }
            else
            {
                backgroundWorker1.CancelAsync();
            }
        }

        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            DirectoryInfo dir = (DirectoryInfo)e.UserState;
            label3.Text = dir.FullName;
        }

    }
}
